(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMTAboutDialog;
{$R *.DFM}
interface
uses
  SysUtils, Windows, Messages, Classes, Controls,Graphics,
  Forms,  ExtCtrls, StdCtrls, Buttons, AHMFreeware;
type
  TAHMAboutInfoForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Image1: TImage;
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
  public
    xlitems : TStrings;
    xlitems2 : TStrings;
  end;

type
  TAHMAboutDialog = class(TComponent)
  private
    FAbout : TAHMAboutFreeStr;
    fact,fsys : TStrings;
    fver : string;
    fFont : TFont;
    Procedure sact(value : TStrings);
    Procedure ssys(value : TStrings);
    Procedure Setfont(value : TFont);
  protected
  public
    constructor Create( AOwner: TComponent ); override;
    destructor Destroy; override;
    Function Execute : Boolean;
  published
    Property About : TAHMAboutFreeStr read FAbout write FAbout;
    Property VersionDescription : String   read fver write fver;
    Property ActualInformation  : TStrings read fact write sact;
    Property SystemInformation  : TStrings read fsys write ssys;
    Property Fonts : TFont read fFont write Setfont;
  end;

var AboutInfoForm : TAHMAboutInfoForm;

implementation

constructor TAHMAboutDialog.Create( AOwner: TComponent );
begin
  fVer  := 'Version 1.0';
  inherited Create( AOwner );
  fFont := TFont.create;
  fAct  := TStringlist.create;
  fSys  := TStringlist.create;
end;

destructor TAHMAboutDialog.Destroy;
begin
  fact.free;
  fsys.free;
  ffont.free;
  inherited Destroy;
end;

procedure TAHMAboutDialog.sact(value : TStrings);
begin
  fact.assign(value);
end;

Function TAHMAboutDialog.Execute : Boolean;
begin
  AboutInfoForm := TAHMAboutInfoForm.create(Application);
  try
    AboutInfoForm.font     :=fFont;
    AboutInfoForm.xlitems  := fact;
    AboutInfoForm.xlitems2 := fsys;
    AboutInfoForm.label2.caption := fver;
    AboutInfoForm.showmodal;
  finally
    AboutInfoForm.Free;
  end;
  result:=true;
end;

procedure TAHMAboutDialog.ssys(value : TStrings);
begin
  fsys.assign(value);
end;

procedure TAHMAboutDialog.Setfont(value : TFont);
begin
  fFont.assign(value);
end;

procedure TAHMAboutInfoForm.FormShow(Sender: TObject);
begin
  Listbox1.items      := xlitems;
  Image1.picture.icon := Application.icon;
  Label1.Caption      := Application.Title;
  Bitbtn2.caption     := 'System Information';
end;

procedure TAHMAboutInfoForm.BitBtn1Click(Sender: TObject);
begin
  close;
end;

procedure TAHMAboutInfoForm.BitBtn2Click(Sender: TObject);
begin
  if (Sender as TBitbtn).caption<>'About Information' then
  begin
    Bitbtn2.Caption :='About Information';
    Listbox1.items.clear;
    Listbox1.items  :=xlitems2;
  end else
  begin
    Bitbtn2.Caption :='System Information';
    listbox1.items.clear;
    Listbox1.items  :=xlitems;
  end;
end;

end.
