(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMTDice;

interface

uses Windows, Messages, SysUtils, Classes,Controls,
     Graphics,AHMFreeware;

type
  TAHMDice = class(TGraphicControl)
  private
    FAbout : TAHMAboutFreeStr;
    FValue : Integer;
    FDotColor : TColor;
    fback,fhback : TColor;
    fHold : Boolean;
    procedure AutoInitialize;
    procedure SetValue(Value : Integer);
    procedure SetDotColor(Value : TColor);
    procedure Holdit(Value : Boolean);
    procedure WMSize(var Message: TWMSize); message WM_PAINT;
    procedure Setback(value : TColor);
    procedure Sethback(value : TColor);
  protected
    procedure Click; override;
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Roll;
    procedure Notification(AComponent: TComponent;Operation: TOperation); override;
  published
    Property About : TAHMAboutFreeStr read FAbout write FAbout;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property NormalBackground : TColor read fback write setback;
    property HoldBackground : TColor read fhback write sethback;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property Value : Integer read FValue write SetValue default 1;
    property Hold : Boolean read FHold write Holdit default false;
    property DotColor : TColor read FDotColor write SetDotColor default clblack;
  end;
implementation

procedure TAHMDice.AutoInitialize;
begin
  FValue := 1;
  FDotColor := clwhite;
end;

procedure TAHMDice.SetValue(Value : Integer);
begin
  FValue := Value;
  if fvalue< 0 then fvalue:=0;
  if fvalue > 6 then fvalue :=6;
  Paint;
end;

procedure TAHMDice.Notification(AComponent: TComponent;Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
end;

procedure TAHMDice.Holdit(Value : Boolean);
begin
  FHold := Value;
  Paint;
end;

procedure TAHMDice.SetDotColor(Value : TColor);
begin
  FDotColor := Value;
  Paint;
end;

procedure TAHMDice.Sethback(Value : TColor);
begin
  Fhback := Value;
  Invalidate;
end;

procedure TAHMDice.Setback(Value : TColor);
begin
  Fback := Value;
  Invalidate;
end;

procedure TAHMDice.Click;
begin
  inherited Click;
end;

constructor TAHMDice.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  AutoInitialize;
  width:=32;
  height:=32;
end;

destructor TAHMDice.Destroy;
begin
  inherited Destroy;
end;

procedure TAHMDice.WMSize(var Message: TWMSize);
begin
  inherited;
  Width:=32;
  Height:=32;
end;

procedure TAHMDice.Paint;
var mybitmap : TBitmap;
begin
  mybitmap:=tbitmap.create;
  mybitmap.width:=32;
  mybitmap.height:=32;
  if FHOLD then
  begin
    mybitmap.canvas.brush.Color:=fhback;
  end else mybitmap.canvas.brush.Color:=fback;
  mybitmap.canvas.rectangle(0,0,width,height);
  mybitmap.canvas.brush.style:=bsclear;
  mybitmap.canvas.roundrect(0,0,width,height,9,9);
  mybitmap.canvas.pen.color:=fdotcolor;
  mybitmap.canvas.brush.color:=fdotcolor;
  mybitmap.canvas.brush.style:=bssolid;
  case fvalue of
    1: mybitmap.canvas.ellipse(13,13,19,19);
    2:
    begin
      mybitmap.canvas.ellipse(5,5,11,11);
      mybitmap.canvas.ellipse(21,21,27,27);
    end;
    3:
    begin
      mybitmap.canvas.ellipse(13,13,19,19);
      mybitmap.canvas.ellipse(5,5,11,11);
      mybitmap.canvas.ellipse(21,21,27,27);
    end;
    4:
    begin
      mybitmap.canvas.ellipse(5,5,11,11);
      mybitmap.canvas.ellipse(21,21,27,27);
      mybitmap.canvas.ellipse(5,21,11,27);
      mybitmap.canvas.ellipse(21,5,27,11);
    end;
    5:
    begin
      mybitmap.canvas.ellipse(5,5,11,11);
      mybitmap.canvas.ellipse(21,21,27,27);
      mybitmap.canvas.ellipse(5,21,11,27);
      mybitmap.canvas.ellipse(21,5,27,11);
      mybitmap.canvas.ellipse(13,13,19,19);
    end;
    6:
    begin
      mybitmap.canvas.ellipse(5,5,11,11);
      mybitmap.canvas.ellipse(21,21,27,27);
      mybitmap.canvas.ellipse(5,21,11,27);
      mybitmap.canvas.ellipse(21,5,27,11);
      mybitmap.canvas.ellipse(5,13,11,19);
      mybitmap.canvas.ellipse(21,13,27,19);
    end;
  end;
  canvas.copyrect(rect(0,0,32,32),mybitmap.canvas,rect(0,0,32,32));
  mybitmap.free;
end;

procedure TAHMDice.Roll;
begin
  if fhold=false then setvalue(random(6)+1);
end;

end.
