(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMTDigital;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls,
  Graphics,AHMFreeware ;

Type
 TAHMDigital = class(TGraphicControl)
  private
    FAbout : TAHMAboutFreeStr;
     fi : integer;
     fdon,fdoff,fback : TColor;
     fonn : TNotifyevent;
     fborder : Boolean;
     ostr : string;
     procedure setfi(value : integer);
     procedure Setfdon(value : TColor);
     procedure Setfdoff(value : TColor);
     procedure Setback(value : TColor);
     procedure SetBorder(value : Boolean);
  protected
    procedure Paint; Override;
  public
    constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
  published
    Property About : TAHMAboutFreeStr read FAbout write FAbout;
    property OnClick;
    Property OnDblClick;
    Property Visible;
    Property Number : Integer read fi write setfi;
    Property DigitOnColor : Tcolor read fdon write setfdon;
    Property DigitShadow : TColor read fdoff write setfdoff;
    Property DigitBackground : TColor read fback write Setback;
    Property Border3D : Boolean read fborder write Setborder;
    Property OnNewNumber : TNotifyevent read fonn write fonn;
  end;
implementation

Procedure AHMDrawDigital(Canvas:TCanvas;X1,Y1,zahl :integer;ActColor,Shadow : TColor);
VAR
 ZAHLSTRING : STRING;
 NENNJUMP   : INTEGER;
 NENNCOUNT  : INTEGER;
 ZAHLHELP   : INTEGER;
 ZAHL2 : INTEGER;
ProCEDURE ZEICHNEZAHL(X,Y,AZ,BZ,CZ,DZ,EZ,FZ,GZ:INTEGER);
Procedure Lineit(x1,y1,x2,y2:integer);
begin
  Canvas.Moveto(x1,y1);
  Canvas.Lineto(x2,y2);
end;
BEGIN
  Canvas.Pen.Color:=ActColor;
  IF AZ=1 THEN  LINEit(X-1,Y+1,X-1,Y+3);
  IF BZ=1 THEN  LINEit(X-1,Y+5,X-1,Y+7);
  IF CZ=1 THEN  LINEit(X+1,Y,X+3,Y);
  IF DZ=1 THEN  LINEit(X+1,Y+8,X+3,Y+8);
  IF EZ=1 THEN  LINEit(X+5,Y+1,X+5,Y+3);
  IF FZ=1 THEN  LINEit(X+5,Y+5,X+5,Y+7);
  IF GZ=1 THEN  LINEit(X+1,Y+4,X+3,Y+4);
  Canvas.Pen.Color:=Shadow;
  IF AZ=1 THEN  LINEit(X,Y,X,Y+2);
  IF BZ=1 THEN  LINEit(X,Y+4,X,Y+6);
  IF CZ=1 THEN  LINEit(X+2,Y-1,X+4,Y-1);
  IF DZ=1 THEN  LINEit(X+2,Y+7,X+4,Y+7);
  IF EZ=1 THEN  LINEit(X+6,Y,X+6,Y+2);
  IF FZ=1 THEN  LINEit(X+6,Y+4,X+6,Y+6);
  IF GZ=1 THEN  LINEit(X+2,Y+3,X+4,Y+3);
END;
ProCEDURE VERSTEHEZAHL(ZAHL1,X,Y: INTEGER);
BEGIN
IF  ZAHL1=1 THEN ZEICHNEZAHL(X,Y,0,0,0,0,1,1,0);
IF  ZAHL1=2 THEN ZEICHNEZAHL(X,Y,0,1,1,1,1,0,1);
IF  ZAHL1=3 THEN ZEICHNEZAHL(X,Y,0,0,1,1,1,1,1);
IF  ZAHL1=4 THEN ZEICHNEZAHL(X,Y,1,0,0,0,1,1,1);
IF  ZAHL1=5 THEN ZEICHNEZAHL(X,Y,1,0,1,1,0,1,1);
IF  ZAHL1=6 THEN ZEICHNEZAHL(X,Y,1,1,1,1,0,1,1);
IF  ZAHL1=7 THEN ZEICHNEZAHL(X,Y,0,0,1,0,1,1,0);
IF  ZAHL1=8 THEN ZEICHNEZAHL(X,Y,1,1,1,1,1,1,1);
IF  ZAHL1=9 THEN ZEICHNEZAHL(X,Y,1,0,1,1,1,1,1);
IF  ZAHL1=0 THEN ZEICHNEZAHL(X,Y,1,1,1,1,1,1,0);
END;
BEGIN
  NENNJUMP:=0;
  NENNCOUNT:=1;
  IF ZAHL>9 THEN NENNCOUNT:=2;
  IF ZAHL>99 THEN NENNCOUNT:=3;
  IF ZAHL>999 THEN NENNCOUNT:=4;
  IF ZAHL>9999 THEN NENNCOUNT:=5;
  IF ZAHL>99999 THEN NENNCOUNT:=6;
  IF ZAHL>999999 THEN NENNCOUNT:=7;
  IF ZAHL>9999999 THEN NENNCOUNT:=8;
  IF ZAHL>99999999 THEN NENNCOUNT:=9;
  IF ZAHL>999999999 THEN NENNCOUNT:=10;
  ZAHLSTRING := INTTOSTR(ZAHL);
  FOR ZAHLHELP:=1 TO NENNCOUNT DO
  BEGIN
    INC(NENNJUMP);
    ZAHL2 := STRTOINT(COPY(ZAHLSTRING,NENNJUMP,1));
    IF (ZAHL<10) AND (Y1=20) THEN
    BEGIN
      VERSTEHEZAHL(0,(X1-9)+NENNJUMP*9,Y1);
      VERSTEHEZAHL(ZAHL2,(X1-1)+NENNJUMP*9,Y1);
    END
    ELSE
    VERSTEHEZAHL(ZAHL2,(X1-9)+NENNJUMP*9,Y1);
   END;
END;


constructor TAHMDigital.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  height:=33;
  width:=100;
  fdon:=clyellow;
  fdoff:=clblack;
  fback:=clolive;
  ostr:='1';
  fi:=123456789;
  fborder:=true;
end;

Destructor TAHMDigital.Destroy;
begin
  inherited Destroy;
end;

Procedure TAHMDigital.Setfdon(value : TColor);
begin
  fdon:=value;
  invalidate;
end;

Procedure TAHMDigital.Setfdoff(value : TColor);
begin
  fdoff:=value;
  invalidate;
end;

Procedure TAHMDigital.Setback(value : TColor);
begin
  fback:=value;
  invalidate;
end;


Procedure TAHMDigital.Setborder(value : Boolean);
begin
  fborder:=value;
  invalidate;
end;


procedure TAHMDigital.Setfi(value : Integer);
var w1,h1 : integer;
begin
  if value>=0 then
  begin
    w1:=round(width/2-4*length(inttostr(fi)));
    h1:=round(height/2-5);
    AHMDrawdigital(Canvas,w1,h1,fi,fback,fback);
    fi:=value;
    if assigned(fonn) then fonn(self);
    w1:=round(width/2-4*length(inttostr(fi)));
    h1:=round(height/2-5);
    AHMDrawdigital(Canvas,w1,h1,fi,fdon,fdoff);
  end;
end;

procedure TAHMDigital.Paint;
var ri,ro : TRect;
begin
  canvas.brush.color:=fback;
  canvas.pen.color:=fback;
  canvas.Rectangle(0,0,width,height);
  ri:=Rect(0,0,width,height);
  ro:=Rect(0,0,width,height);
  setfi(fi);
end;

end.
